function nextPage() {
  date.setMonth(date.getMonth() + 1);
  buildDates();
}

function prevPage() {
  var month = date.getMonth();
  var year = date.getFullYear();
  if (month == 0) {
    date.setMonth(11);
    date.setFullYear(year-1);
  } else {
    date.setMonth(month-1);
  }
  buildDates();
}

function dateClick(day,month,year) {
  window.status='date ' + day + ' ' + (month+1) + ' ' + (year);
}

function yearClick(e) {
  window.status='year ' + (date.getMonth()+1) + ' ' + (date.getFullYear());
  e.stopPropagation();
}

function monthClick(e) {
  window.status='month ' + (date.getMonth()+1) + ' ' + (date.getFullYear());
  e.stopPropagation();
}

function infoClick(e) {
  window.status='info';
  e.stopPropagation();
}

function ignoreEvent(e) {
  e.stopPropagation();
}

window.onmousedown = function() {
  //window.getSelection().collapse();
  window.status='drag';
};

/*window.onmouseup = function() {
  window.getSelection().collapse();
};*/

window.onload = function() {
  window.status='load';
};

function setDate(month,year) {
  date = new Date();
  date.setMonth(month-1);
  date.setFullYear(year);
}

function getStartDayBeforeMonth(d) {
  var d2 = new Date();
  d2.setTime(d.getTime());
  while (d2.getDay() != startDay
     || (d2.getMonth() == d.getMonth() && d2.getDate() > startDay)) {
    d2.setDate(d2.getDate() - 1);
  }
  return d2;
}

var getMonthName = function (month) {}
var getDayName = function (day) {}
var shortWeekName = '';

var dateClicks = true;
var weekClicks = true;
var calendarWeeks = false;
var calendarWeekStartMonth = 0;
var calendarWeekRule = 'firstThursday';
var startDay = 1;
var date = new Date();

function getCalendarWeek(d) {
  var d2 = new Date();
  
  var startingDayOffset = startDay;
  if (d.getDay() < startingDayOffset) startingDayOffset -= 7;
  
  switch(calendarWeekRule) {
  case 'firstFullWeek':
    d2.setTime(d.getTime() + (startingDayOffset - d.getDay())*86400000);
    break;
  case 'firstPartialWeek':
    d2.setTime(d.getTime() + (6 + startingDayOffset - d.getDay())*86400000);
    break;
  case 'firstThursday':
    d2.setTime(d.getTime() + (4 + startingDayOffset - d.getDay())*86400000);
    break;
  }
  
  var week = 0;
  while (d2.getMonth() != calendarWeekStartMonth) {
    week += 1;
    d2.setTime(d2.getTime() - 86400000*7);
  }
  while (d2.getMonth() == calendarWeekStartMonth) {
    week += 1;
    d2.setTime(d2.getTime() - 86400000*7);
  }
  return week;
}

function buildHeader() {
  var calendar = document.getElementById('calendar');
  if (calendarWeeks) {
    calendar.className = 'show-weeks';
  } else {
    calendar.className = '';
  }
  
  var calendarHead = calendar.getElementsByTagName('thead');
  if (calendarHead.length > 0) calendar.removeChild(calendarHead[0]);
  calendarHead = document.createElement('thead');
  var row = document.createElement('tr');
  
  for (i = 0;i < 7;i++) {
    var dayName = getDayName((i+startDay) % 7);
    var cell = document.createElement('th');
    cell.id = dayName;
    cell.appendChild(document.createTextNode(dayName[0].toUpperCase()));
    row.appendChild(cell);
  }
  
  //calendar weeks
  if (calendarWeeks) {
    var cell = document.createElement('th');
    cell.id = 'week';
    cell.appendChild(document.createTextNode(shortWeekName));
    row.appendChild(cell);
  }
  
  calendarHead.appendChild(row);
  calendar.appendChild(calendarHead);
}

function buildDates() {
  var tm = new Date();
  var calendar = document.getElementById('calendar');
  
  //month
  var month = document.getElementById('month');
  if (month.firstChild) month.removeChild(month.firstChild);
  
  month.appendChild(document.createTextNode(getMonthName(date.getMonth())));
  
  //year
  var year = document.getElementById('year');
  if (year.firstChild) year.removeChild(year.firstChild);
  year.appendChild(document.createTextNode(date.getFullYear()));
  
  //calendar
  var calendarWeek;
  var calendarBody = calendar.getElementsByTagName('tbody');
  if (calendarBody.length > 0) calendar.removeChild(calendarBody[0]);
  calendarBody = document.createElement('tbody');
  var d2 = getStartDayBeforeMonth(date,startDay);
  for (i=0;i<6;i++) {
    var row = document.createElement('tr');
    for (j=0;j<7;j++) {
      var cell = document.createElement('td');
      var c = d2.getDate();
      if (d2.getDay() == 4) {
        if (calendarWeeks) calendarWeek = getCalendarWeek(d2);
      }
      if (dateClicks) {
        var anchor = document.createElement('a');
        anchor.appendChild(document.createTextNode(c));
        cell.appendChild(anchor);
      } else {
        cell.appendChild(document.createTextNode(c));
      }
      if (d2.getFullYear() == tm.getFullYear()
       && d2.getMonth() == tm.getMonth()
       && d2.getDate() == tm.getDate()) {
        cell.id = 'today';
      }
      if (d2.getMonth() < date.getMonth()) {
        cell.className = 'last-month';
      } else if (d2.getMonth() > date.getMonth()) {
        cell.className = 'next-month';
      } else {
        cell.className = 'this-month';
      }
      cell.onclick = new Function('e',
        'dateClick('+d2.getDate()+','+d2.getMonth()+','+d2.getFullYear()+');'
      );
      cell.onmousedown = ignoreEvent;
      row.appendChild(cell);
      d2.setDate(d2.getDate() + 1);      
    }
    //calendar weeks
    if (calendarWeeks) {
      cell = document.createElement('td');
      cell.className = 'weeks-column';
      if (weekClicks) {
        var anchor = document.createElement('a');
        anchor.appendChild(document.createTextNode(calendarWeek));
        cell.appendChild(anchor);
      } else {
        cell.appendChild(document.createTextNode(calendarWeek));
      }
      row.appendChild(cell); 
    }
    //append row
    calendarBody.appendChild(row);
  }
  calendar.appendChild(calendarBody);
}

var fadeTarget = 0;
var fadeLevel = 0;

function fadeIn() {
  fadeTarget = 1.0;
  window.setTimeout(fade,10);
}

function fadeOut() {
  fadeTarget = 0.0;
  window.setTimeout(fade,10);
}

function fade() {
  if (fadeTarget > fadeLevel) {
    fadeLevel = fadeLevel + 0.01;
    if (fadeTarget < fadeLevel) fadeLevel = fadeTarget;
  } else if (fadeTarget < fadeLevel) {
    fadeLevel = fadeLevel - 0.01;
    if (fadeTarget > fadeLevel) fadeLevel = fadeTarget;
  }
  document.getElementById('info').style.opacity = fadeLevel;
  if (fadeLevel != fadeTarget) {
    window.setTimeout(fade,10);
  }
}

var cyclePeriod = 1000;
var cycleID = 0;

function prevStart(e) {
  cycleID += 1;
  cyclePeriod = 1000;
  prevCycle(cycleID);
  e.stopPropagation();
}

function prevStop() {
  cycleID += 1;
}

function prevCycle(id) {
  if (cycleID == id) {
    prevPage();
    window.setTimeout(prevCycle,cyclePeriod,id);
    cyclePeriod /= 2;
  }
}

function nextStart(e) {
  cycleID += 1;
  cyclePeriod = 1000;
  nextCycle(cycleID);
  e.stopPropagation();
}

function nextStop() {
  cycleID += 1;
}

function nextCycle(id) {
  if (cycleID == id) {
    nextPage();
    window.setTimeout(nextCycle,cyclePeriod,id);
    cyclePeriod /= 2;
  }
}

function initialise() {

  var previous = document.getElementById('previous');
  previous.onmousedown = prevStart;
  previous.onmouseup = prevStop;
  
  var next = document.getElementById('next');
  next.onmousedown = nextStart;
  next.onmouseup = nextStop;
  
  var month = document.getElementById('month');
  month.onclick = monthClick;
  month.onmousedown = ignoreEvent;
  
  var year = document.getElementById('year');
  year.onclick = yearClick;
  year.onmousedown = ignoreEvent;
  
  var info = document.getElementById('info');
  info.onclick = infoClick;
  info.onmousedown = ignoreEvent;
  
  buildHeader();
  buildDates();

}